;;; remap-for-emacs.el --- console key sequences for Emacs

;; Copyright 2012, 2013, 2014, 2017, 2019 Kevin Ryde
;;
;; Author: Kevin Ryde <user42_kevin@yahoo.com.au>
;; Version: 0
;; Keywords: terminals, linux
;; URL: http://user42.tuxfamily.org/remap-for-emacs/index.html

;; remap-for-emacs.el is free software; you can redistribute it and/or
;; modify it under the terms of the GNU General Public License as published
;; by the Free Software Foundation; either version 3, or (at your option)
;; any later version.
;;
;; remap-for-emacs.el is distributed in the hope that it will be
;; useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You can get a copy of the GNU General Public License online at
;; <http://www.gnu.org/licenses/>.


;;; Commentary:
;;
;; This is Emacs setups for the Linux console key sequences defined in the
;; accompanying remap-for-emacs.inc.
;;
;; Some of remap-for-emacs.inc is sequences Emacs already recognises and
;; needs nothing more.  Others sequences are done here through
;; `function-key-map'.
;;

;;; History:

;; Version 1 - the first version

;;; Code:

;; `input-decode-map' is new in emacs24
;; is it now the better place for these mappings ?

(define-key function-key-map "\033_Ctab\033\\" [(control tab)])
(define-key function-key-map "\033_Cret\033\\" [(control return)])

(define-key function-key-map "\033_Cf1\033\\" [(control f1)])
(define-key function-key-map "\033_Cf2\033\\" [(control f2)])
(define-key function-key-map "\033_Cf3\033\\" [(control f3)])
(define-key function-key-map "\033_Cf4\033\\" [(control f4)])
(define-key function-key-map "\033_Cf5\033\\" [(control f5)])
(define-key function-key-map "\033_Cf6\033\\" [(control f6)])
(define-key function-key-map "\033_Cf7\033\\" [(control f7)])
(define-key function-key-map "\033_Cf8\033\\" [(control f8)])
(define-key function-key-map "\033_Cf9\033\\" [(control f9)])
(define-key function-key-map "\033_Cf10\033\\" [(control f10)])
(define-key function-key-map "\033_Cf11\033\\" [(control f11)])
(define-key function-key-map "\033_Cf12\033\\" [(control f12)])

(provide 'remap-for-emacs)

;;; remap-for-emacs.el ends here
