;; Copyright 2009, 2010 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.



;;-----------------------------------------------------------------------------
;; completing-help.el tie-in
;;
;; now using strings in the completing-read table, so don't need this ...
;;
;; As of completing-help.el 3.13, `completing-help-alist-get-info' doesn't
;; handle alists with symbols in the car's, as opposed to strings, like
;; `finder-known-keywords' has.

(defvar completing-help-groups) ;; quieten the byte compiler

(defvar checkdoc-keywords-completing-help-group
  '(:predicate checkdoc-keywords-completing-help-p
    :get       checkdoc-keywords-completing-help-get
    :info-head " - "
    :info-tail ""))

(defun checkdoc-keywords-completing-help-p ()
  "Return non-nil when completing from `finder-known-keywords'."
  (eq minibuffer-completion-table finder-known-keywords))

(defun checkdoc-keywords-completing-help-get (str)
  "Return a help string for finder keyword STR, or nil if unknown."
  (cdr (assoc (intern-soft str) finder-known-keywords)))

(eval-after-load "completing-help"
  '(if (boundp 'checkdoc-keywords-completing-help-group) ;; in case unloaded
       (add-to-list 'completing-help-groups
                    'checkdoc-keywords-completing-help-group)))

(defun checkdoc-keywords-unload-function ()

  ;; mustn't leave an unbound variable name in `completing-help-groups' or
  ;; it will error out (as of completing-help.el 3.13)
  (if (boundp 'completing-help-groups)
      (setq completing-help-groups
            (remove 'checkdoc-keywords-completing-help-group
                    completing-help-groups)))

  ;; and do normal unload-feature actions too
  nil)


    ;;-------------------------------------------------------------------------
    ;; checkdoc-keywords-completing-help-get

    (let ((got (checkdoc-keywords-completing-help-get "lisp")))
      (unless (stringp got)
        (error "checkdoc-keywords-completing-help-get got %S" got))
      (setq count (1+ count)))


