;; Copyright 2019 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;; adapted from the elisp manual
(defun my-hyperify (prompt)
  (let ((event (read-event)))
    (message "event: %S" event)
    (vector (my-add-hyper-modifier event))))
(defun my-add-hyper-modifier (event)
  (cond ((numberp event)
         (logior (lsh 1 24) event))
        ((memq 'hyper (event-modifiers event))
         event)
        (t
         (let ((symbol (if (symbolp event) event (car event))))
           (setq symbol (intern (concat "H-" (symbol-name symbol))))
           (if (symbolp event)
               symbol
             (cons symbol (cdr event)))))))
(event-modifiers ?a)
(event-modifiers ?\H-a)
(my-add-hyper-modifier ?a)
(my-add-hyper-modifier ?a)

(define-key global-map [f9] nil)
(define-key function-key-map [f9] 'my-hyperify)
