;; Copyright 2011, 2012 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(add-to-list 'load-path (expand-file-name ".."))

(defun my-run-test ()
  (require 'miscbits-el-loaddefs)
  (let ((count 0)
        (tempbuf "*t-help-xref-elfiles--temp*"))
    (switch-to-buffer tempbuf)

    ;;-------------------------------------------------------------------------
    ;; enable

    (require 'help-xref-elfiles)
    (describe-function 'thing-at-point)


    ;;-------------------------------------------------------------------------
    ;; help-xref-elfiles-button-in-region-p

    (if (not (featurep 'button))
        (message "skip, no button.el")
    
      (setq count (1+ count))
      (erase-buffer)
      (insert-text-button "abc" :type 'help-xref-elfiles)
    
      (unless (help-xref-elfiles-button-in-region-p (point-min) (point-max))
        (error "button-in-region-p whole buffer"))
      (unless (help-xref-elfiles-button-in-region-p (1+ (point-min)) (point-max))
        (error "button-in-region-p +1,max"))
    
      (insert "xyz")
      (unless (help-xref-elfiles-button-in-region-p (point-min) (point-max))
        (error "button-in-region-p"))
    
      (when (help-xref-elfiles-button-in-region-p (1- (point-max)) (point-max))
        (error "button-in-region-p"))
      (when (help-xref-elfiles-button-in-region-p (- (point-max) 3) (point-max))
        (error "button-in-region-p"))
    
      (unless (help-xref-elfiles-button-in-region-p (+ (point-min) 2) (+ (point-min) 3))
        (error "button-in-region-p +2,+3  %S"
               (buffer-substring (+ (point-min) 2) (+ (point-min) 3)))))


    ;;-------------------------------------------------------------------------
    ;; unload-feature

    (require 'help-xref-elfiles)
    (unload-feature 'help-xref-elfiles t)
    (setq count (1+ count))

    (describe-function 'thing-at-point)

    ;; load/unload again
    (require 'help-xref-elfiles)
    (unload-feature 'help-xref-elfiles t)
    (setq count (1+ count))


    ;;-------------------------------------------------------------------------

    (bury-buffer)
    (message "  %d tests" count)
    count))
